<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="50%">
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="6">
                <v-text-field label="Username*" v-model="user.username" :disabled="isEdit || statusProgress" @blur="setResetError" :error-messages="error_payload.username" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Email*" v-model="user.email" :disabled="statusProgress" required @blur="setResetError" :error-messages="error_payload.email" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="6">
                <v-text-field label="First Name*" v-model="user.first_name" :disabled="statusProgress" required @blur="setResetError" :error-messages="error_payload.first_name" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Last Name" v-model="user.last_name" :disabled="statusProgress" required @blur="setResetError" :error-messages="error_payload.last_name" />
              </v-col>
            </v-row>
            <v-row v-if="!isEdit">
              <v-col cols="6">
                <v-text-field label="Password*" v-model="user.password" type="password" :disabled="statusProgress" required v-if="!isEdit" @blur="setResetError" :error-messages="error_payload.password" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Password Confirm*" v-model="user.confirm_password" type="password" :disabled="statusProgress" required v-if="!isEdit" @blur="setResetError" :error-messages="error_payload.confirm_password" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-text-field label="Telegram ID*" type="number" v-model="user.telegram_id" :disabled="statusProgress" required @blur="setResetError" :error-messages="error_payload.telegram_id" />
              </v-col>
              <v-col cols="3">
                <v-text-field
                    label="Limit Login*"
                    type="number"
                    v-model="user.limit_login"
                    :disabled="statusProgress || statusUniqueLogin || isEdit2"
                    required
                    @blur="setResetError" :error-messages="error_payload.limit_login"
                />
              </v-col>
              <v-col cols="5">
                <v-text-field label="Limit Failed Password*" type="number" v-model="user.limit_fail" :disabled="statusProgress || isEdit2" required @blur="setResetError" :error-messages="error_payload.limit_fail" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-menu
                    v-model="menu.expired_date"
                    :close-on-content-click="false"
                    :nudge-right="40"
                    transition="scale-transition"
                    offset-y
                    min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        :disabled="statusProgress || isEdit2"
                        v-model="user.expired_date"
                        label="Tanggal Expire"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                        @blur="setResetError"
                        :error-messages="error_payload.expired_date"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                      v-model="user.expired_date"
                      @input="menu.expired_date = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
              <v-col cols="6">
                <v-menu
                    v-model="menu.expired_password_date"
                    :close-on-content-click="false"
                    :nudge-right="40"
                    transition="scale-transition"
                    offset-y
                    min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        :disabled="statusProgress || isEdit2"
                        v-model="user.expired_password_date"
                        label="Tanggal Password Expire"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                        @blur="setResetError"
                        :error-messages="error_payload.expired_password_date"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                      v-model="user.expired_password_date"
                      @input="menu.expired_password_date = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
              <v-col cols="2">
                <v-checkbox
                    :disabled="statusProgress || isEdit2"
                    v-model="user.enabled"
                    label="Active"
                    class="shrink mr-2 mt-0"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                    :disabled="statusProgress || isEdit2"
                    v-model="userRole"
                    :items="roles"
                    item-text="name"
                    item-value="id"
                    label="Role"
                    multiple
                    chips
                    return-object
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                    :disabled="statusProgress"
                    v-model="userRegional"
                    :items="regionals"
                    item-text="name"
                    item-value="id"
                    label="Regional (Optional)"
                    multiple
                    chips
                    return-object
                    @change="doChageRegional"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-combobox
                    :disabled="statusProgress"
                    v-model="userWitel"
                    :items="witels"
                    item-text="name"
                    item-value="id"
                    label="Witel (Optional)"
                    multiple
                    chips
                    return-object
                    @change="doChangeWitel"
                />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import userService from "../service/UserService";
import roleService from "../service/RoleService";
import regionalService from "../service/RegionalService";
import witelService from "../service/WitelService";
import userGroupService from "../service/UserGroupService";
import {checkError400} from "../utils/util";

export default {
  name: "UserForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      roles: [],
      regionals: [],
      witels: [],
      userRole: [],
      userRegional: [],
      userWitel: [],
      userWitelOld: [],
      user: {
        first_name: null,
        last_name: null,
        telegram_id: null,
        username: null,
        email: null,
        enabled: false,
        password: null,
        confirm_password: null,
        default_user: false,
        resource_accesses: [
          {
            client_id: "web",
            roles: [
              {
                id: null,
                name: null,
              }
            ],
          }
        ],
        groups: [
          {
            username: null,
            type: 0,
            group_id: null,
          }
        ],
        fail_pass: 0,
        limit_login: 1,
        limit_fail: 3,
        expired_date: null,
        expired_password_date: null,
      },
      error_payload: {
        first_name: [],
        telegram_id: [],
        username: [],
        email: [],
        enabled: [],
        password: [],
        confirm_password: [],
        default_user: [],
        roles: [],
        fail_pass: [],
        limit_login: [],
        limit_fail: [],
        expired_date: [],
        expired_password_date: [],
      },
      title: null,
      dialog: false,
      isEdit: false,
      isEdit2: false,
      statusProgress: false,
      statusUniqueLogin: false,
      menu: {
        expired_date: false,
        expired_password_date: false,
      },
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    async doAdd(title, isEdit) {
      this.title = title
      this.doReset()
      this.dialog = true
      this.isEdit = isEdit
      this.isEdit2 = false
      this.statusProgress = true
      await this.doLoadRoles()
      await this.doLoadRegional()
      this.statusProgress = false
    },
    doEdit(id, title, isEdit, isEdit2) {
      this.title = title
      this.setResetError()
      this.dialog = true
      this.isEdit = isEdit
      this.isEdit2 = isEdit2
      this.retrieveUser(id)
    },
    doReset() {
      this.user.first_name = null
      this.user.last_name = null
      this.user.telegram_id = null
      this.user.username = null
      this.user.password = null
      this.user.confirm_password = null
      this.user.email = null
      this.user.enabled = false
      this.user.default_user = false
      this.user.expired_date = null
      this.user.expired_password_date = null
      this.user.resource_accesses = []
      this.user.groups = []
      this.user.fail_pass = 0
      this.user.limit_login = 1
      this.user.limit_fail = 3

      this.userRole = []
      this.userRegional = []
      this.userWitel = []
      this.setResetError()
    },
    setResetError() {
      this.error_payload.first_name = []
      this.error_payload.telegram_id = []
      this.error_payload.username = []
      this.error_payload.password = []
      this.error_payload.confirm_password = []
      this.error_payload.email = []
      this.error_payload.enabled = []
      this.error_payload.default_user = []
      this.error_payload.expired_date = []
      this.error_payload.expired_password_date = []
      this.error_payload.fail_pass = []
      this.error_payload.limit_login = []
      this.error_payload.limit_login = []
      this.error_payload.limit_fail = []
    },
    async doSaveOrUpdate() {
      this.user.resource_accesses = []
      if (this.userRole.length > 0) {
        let resource_access = {
          client_id: 'web',
          roles: this.userRole,
        }
        this.user.resource_accesses.push(resource_access)
        console.log(this.user.resource_accesses)
      }

      this.user.groups = []
      if (this.userRegional.length > 0 && this.userWitel.length > 0) {
        for (let witel of this.userWitel) {
          for (let regional of this.userRegional) {
            if (regional.id === witel.parent) {
              let group = {
                username: this.user.username,
                type: 1,
                group_id: regional.id,
                group_parent: null,
              }
              this.user.groups.push(group)

              let group_witel = {
                username: this.user.username,
                type: 2,
                group_id: witel.id,
                group_parent: witel.parent,
              }
              this.user.groups.push(group_witel)
            }
          }
        }
      }

      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(this.user)
      } else {
        await this.doUpdate(this.user)
      }
      this.statusProgress = false
    },
    doSave(data) {
      userService.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    doUpdate(data) {
      userService.update(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.dialog = false
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
    },
    async retrieveUser(id) {
      this.statusProgress = true
      await userService.getByUsername(id)
          .then(async res => {
            let status = res.data.status
            this.userRole = []
            if (status === 'SUCCESS') {
              await this.doLoadRoles()
              this.user = res.data.data
              for (let resource_access of this.user.resource_accesses) {
                if (resource_access.client_id === 'web') {
                  for (let roles of resource_access.roles) {
                    let role = {
                      id: roles.id,
                      name: roles.name,
                    }
                    this.userRole.push(role)
                  }
                }
              }
              await this.doLoadRegional()
              await userGroupService.getByUsernam(id).then(async resRegional => {
                let status = resRegional.data.status
                this.userRegional = []
                if (status === 'SUCCESS') {
                  let regionals = resRegional.data.data
                  regionals.sort(userGroupService.sortOrder('group_id'))
                  this.regionals.sort(userGroupService.sortOrder('group_id'))
                  for (let i in this.regionals) {
                    for (let j in regionals) {
                      if (regionals[j].type === 1 && this.regionals[i].id === regionals[j].group_id) {
                        let regional = {
                          id: this.regionals[i].id,
                          name: this.regionals[i].name,
                        }
                        this.userRegional.push(regional)
                        this.userRegional.sort(userGroupService.sortOrder('id'))
                      }
                    }
                  }
                  await this.doChageRegional()
                }
                await userGroupService.getByUsernam(id).then(resWitel => {
                  let status = resWitel.data.status
                  this.userWitel = []
                  this.userWitelOld = []
                  if (status === 'SUCCESS') {
                    let witels = resWitel.data.data
                    witels.sort(userGroupService.sortOrder('group_id'))
                    this.witels.sort(userGroupService.sortOrder('group_id'))
                    for (let i in this.witels) {
                      for (let j in witels) {
                        if (witels[j].type === 2 && this.witels[i].id === witels[j].group_id) {
                          let witel = {
                            id: this.witels[i].id,
                            name: this.witels[i].name,
                            parent: this.witels[i].parent,
                          }
                          this.userWitel.push(witel)
                          this.userWitelOld.push(witel)
                          this.userWitel.sort(userGroupService.sortOrder('parent'))
                          this.userWitelOld.sort(userGroupService.sortOrder('parent'))
                        }
                      }
                    }
                  }
                })
              })
            } else {
              this.$refs.dlgMsg.doOpenMsg(res.data.message)
            }
          }).catch(ex => {
            let {status} = ex.response
            if (status !== 404) {
              this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
            }
      })
      this.statusProgress = false
    },
    doLoadRoles() {
      roleService.getAll().then(resp => {
        let status = resp.data.status
        if (status === 'SUCCESS') {
          this.roles = []
          let roles = resp.data.data
          for (let i in roles) {
            let role = {
              id: roles[i].id,
              name: roles[i].name,
            }
            this.roles.push(role)
          }
        }
      })
    },
    async doLoadRegional() {
      await regionalService.getAll().then(resp => {
        let status = resp.data.status
        if (status === 'SUCCESS') {
          this.regionals = []
          let regionals = resp.data.data
          for (let i in regionals) {
            let regional = {
              id: regionals[i].id,
              name: regionals[i].nama,
            }
            this.regionals.push(regional)
            this.regionals.sort(userGroupService.sortOrder('id'))
          }
        }
      })
    },
    async doChageRegional() {
      let regional_id = []
      for (let i in this.userRegional) {
        regional_id.push(this.userRegional[i].id)
      }
      if (regional_id.length > 0) {
        this.witels = []
        this.userWitel = []
        await witelService.getRegionals(regional_id).then(resp => {
          let status = resp.data.status
          if (status === 'SUCCESS') {
            let witels = resp.data.data
            for (let i in witels) {
              let witel = {
                id: witels[i].id,
                name: witels[i].nama,
                parent: witels[i].regional_id,
              }
              this.witels.push(witel)
              this.witels.sort(userGroupService.sortOrder('parent'))
            }
            for (let i in this.witels) {
              for (let j in this.userWitelOld) {
                if (this.witels[i].id === this.userWitelOld[j].id) {
                  this.userWitel.push(this.userWitelOld[j])
                  this.userWitel.sort(userGroupService.sortOrder('parent'))
                }
              }
            }
          }
        })
      } else {
        this.witels = []
        this.userWitel = []
        this.userWitelOld = []
      }
    },
    doChangeWitel() {
      this.userWitelOld = this.userWitel
    }
  },
}
</script>

<style scoped>

</style>